var DISABLED = 0;
var ENABLED = 1;
var LETSENCRYPT = 2;
(function() {
  getSystemAccessInfo();
  jQuery('#system_access_manager_hostname').focus(function() {
    jQuery('#system_access_manager_hostname').attr('class', 'unas_input');
  });
  jQuery('#system_access_manager_hostname').blur(function() {

  });

  jQuery('#system_access_manager_https_port').focus(function() {
    jQuery('#system_access_manager_https_port').attr('class', 'unas_input');
  });
  jQuery('#system_access_manager_https_port').blur(function() {

  });

  jQuery('#system_access_manager_http_port').focus(function() {
    jQuery('#system_access_manager_http_port').attr('class', 'unas_input');
  });
  jQuery('#system_access_manager_http_port').blur(function() {

  });
  jQuery('#system_access_manager_hostname').keyup(function() {
    SystemAccessSubmitCheck();
  });
  jQuery('#system_access_manager_serveralias').keyup(function() {
    SystemAccessSubmitCheck();
  });
  jQuery('#system_access_manager_serveradmin').keyup(function() {
    SystemAccessSubmitCheck();
  });
  jQuery('#system_access_manager_https_port').keyup(function() {
    SystemAccessSubmitCheck();
  });
  jQuery('#system_access_manager_http_port').keyup(function() {
    SystemAccessSubmitCheck();
  });
  jQuery('#system_access_manager_access_policy').change(function() {
    SystemAccessSubmitCheck();
  });
})();

function set_cert_date(date_from, date_to) {
  jQuery("#systemaccess_cert_date_li").attr('style', 'display:block;');
  jQuery("#systemaccess_cert_date").text(date_from + " - " + date_to);
}

function getSystemAccessInfo() {
  jQuery("#system_access_manager_cont_waiting").attr('style', 'display:block;');
  jQuery("system_access_manager_cont_logo").attr('style', 'display:block;');
  jQuery.ajax({
    url: "/apps/systemaccess/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.stringify({
      "cmd": "systemaccess_get_status",
      "token": UToken
    }),
    timeout: 30000,
    dataType: "json",
    contentType: "application/json",
    success: function(data) {
      if (data.err == 0) {
        var result = data.results;
        jQuery("#system_access_manager_hostname").val(result.hostname);
        jQuery("#system_access_manager_serveralias").val(result.serveralias);
        jQuery("#system_access_manager_serveradmin").val(result.email);
        jQuery("#system_access_manager_http_port").val(result.http_port);
        jQuery("#system_access_manager_https_port").val(result.https_port);
        jQuery("#system_access_manager_access_policy").val(result.policy);

        var cert_status = jQuery("#systemaccess_cert_status");
        switch (result.cert) {
          case DISABLED:
            cert_status.text(UNAS._("##$@systemaccess@$##Not configured##$@systemaccess@$##"));
            jQuery("#system_access_manager_letsencrypt").attr("class", "unas_button_content");
            jQuery("#system_access_manager_letsencrypt").attr("onclick", "letsencrypt();");
            jQuery("#system_access_manager_letsencrypt").attr("title", "");
            break;

          case ENABLED:
            cert_status.text(UNAS._("##$@systemaccess@$##Manual##$@systemaccess@$##"));
            set_cert_date(result.cert_date.from, result.cert_date.to);
            jQuery("#system_access_manager_letsencrypt").attr("class", "unas_button_content");
            jQuery("#system_access_manager_letsencrypt").attr("onclick", "letsencrypt();");
            jQuery("#system_access_manager_letsencrypt").attr("title", "");
            break;

          case LETSENCRYPT:
            cert_status.text("Let's encrypt");
            set_cert_date(result.cert_date.from, result.cert_date.to);
            if (new Date(result.cert_date.to).getTime() - new Date().getTime() > 2592000000) {
              // More than 1 month before expire.
              jQuery("#system_access_manager_letsencrypt").attr("class", "unas_button_content_disabled");
              jQuery("#system_access_manager_letsencrypt").attr("onclick", "javascript:void(0);");
              jQuery("#system_access_manager_letsencrypt").attr("title", UNAS._("##$@systemaccess@$##There is more than one month before expire.##$@systemaccess@$##"));
            } else {
              jQuery("#system_access_manager_letsencrypt").attr("class", "unas_button_content");
              jQuery("#system_access_manager_letsencrypt").attr("onclick", "letsencrypt();");
              jQuery("#system_access_manager_letsencrypt").attr("title", "");
            }
            break;

          default:
            cert_status.text(UNAS._("##$@systemaccess@$##Not configured##$@systemaccess@$##"));
            jQuery("#system_access_manager_letsencrypt").attr("class", "unas_button_content");
            jQuery("#system_access_manager_letsencrypt").attr("onclick", "letsencrypt();");
            jQuery("#system_access_manager_letsencrypt").attr("title", "");
            break;
        }
      }
      jQuery("#system_access_manager_cont_waiting").attr('style', 'display:none;');
      jQuery("system_access_manager_cont_logo").attr('style', 'display:none;');
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
      jQuery("#system_access_manager_cont_waiting").attr('style', 'display:none;');
      jQuery("system_access_manager_cont_logo").attr('style', 'display:none;');
    }
  });
}

function SystemAccessSubmitCheck() {
  if (SystemAccessInputCheck()) {
    jQuery("#systemaccess_setup_submit").attr("class", "unas_button");
  } else {
    jQuery("#systemaccess_setup_submit").attr("class", "unas_button_disabled");
  }
}

function SystemAccessInputCheck() {
  var name = jQuery("#system_access_manager_hostname").val();
  var alias = jQuery("#system_access_manager_serveralias").val();
  var email = jQuery("#system_access_manager_serveradmin").val();
  var http_port = jQuery("#system_access_manager_http_port").val();
  var https_port = jQuery("#system_access_manager_https_port").val();
  port_reg = new RegExp('^[0-9]{2,}$');
  hostname_reg = new RegExp('^[a-zA-Z][a-zA-Z0-9\-]{1,63}$');
  alias_reg = new RegExp('^(?=^.{3,255}$)[a-zA-Z0-9][-a-zA-Z0-9]{0,62}(\.[a-zA-Z0-9][-a-zA-Z0-9]{0,62})+$');
  email_reg = new RegExp('^[a-zA-Z0-9_-]+@[a-zA-Z0-9_-]+(\.[a-zA-Z0-9_-]+)+$');

  if (name == "") {
    jQuery('#system_access_manager_hostname').attr('class', 'unas_input_error');
    jQuery("#system_access_manager_hostname_warning").attr('class', "unas_icon_error");
    jQuery("#system_access_manager_hostname_warning").attr('title', UNAS._('##$@systemaccess@$##Can not be empty!##$@systemaccess@$##'));
    return false;
  } else {
    jQuery('#system_access_manager_hostname').attr('class', 'unas_input');
    jQuery("#system_access_manager_hostname_warning").attr('class', "");
    jQuery("#system_access_manager_hostname_warning").attr('title', '');
  }
  if (http_port == "") {
    jQuery("#system_access_manager_http_port").attr('class', 'unas_input_error');
    jQuery("#system_access_manager_http_port_warning").attr('class', "unas_icon_error");
    jQuery("#system_access_manager_http_port_warning").attr('title', UNAS._('##$@systemaccess@$##Can not be empty!##$@systemaccess@$##'));
    return false;
  } else {
    jQuery('#system_access_manager_http_port').attr('class', 'unas_input');
    jQuery("#system_access_manager_http_port_warning").attr('class', "");
    jQuery("#system_access_manager_http_port_warning").attr('title', '');
  }
  if (https_port == "") {
    jQuery("#system_access_manager_https_port").attr('class', 'unas_input_error');
    jQuery("#system_access_manager_https_port_warning").attr('class', "unas_icon_error");
    jQuery("#system_access_manager_https_port_warning").attr('title', UNAS._('##$@systemaccess@$##Can not be empty!##$@systemaccess@$##'));
    return false;
  } else {
    jQuery('#system_access_manager_https_port').attr('class', 'unas_input');
    jQuery("#system_access_manager_https_port_warning").attr('class', "");
    jQuery("#system_access_manager_https_port_warning").attr('title', '');
  }
  if (http_port == https_port) {
    jQuery("#system_access_manager_http_port").attr('class', 'unas_input_error');
    jQuery("#system_access_manager_http_port_warning").attr('class', "unas_icon_error");
    jQuery("#system_access_manager_http_port_warning").attr('title', UNAS._('##$@systemaccess@$##Can not be the same!##$@systemaccess@$##'));
    jQuery("#system_access_manager_https_port").attr('class', 'unas_input_error');
    jQuery("#system_access_manager_https_port_warning").attr('class', "unas_icon_error");
    jQuery("#system_access_manager_https_port_warning").attr('title', UNAS._('##$@systemaccess@$##Can not be the same!##$@systemaccess@$##'));
    return false;
  }
  if (hostname_reg.exec(name) == null) {
    jQuery('#system_access_manager_hostname').attr('class', 'unas_input_error');
    jQuery("#system_access_manager_hostname_warning").attr('class', "unas_icon_error");
    jQuery("#system_access_manager_hostname_warning").attr('title', UNAS._('##$@systemaccess@$##valid characters A-Za-z0-9- and length cannot be more than 64.##$@systemaccess@$##'));
    return false;
  } else {
    jQuery("#system_access_manager_hostname").attr('class', 'unas_input');
    jQuery("#system_access_manager_hostname_warning").attr('class', "");
    jQuery("#system_access_manager_hostname_warning").attr('title', '');
  }
  if (alias_reg.exec(alias) == null) {
    jQuery('#system_access_manager_serveralias').attr('class', 'unas_input_error');
    jQuery("#system_access_manager_serveralias_warning").attr('class', "unas_icon_error");
    jQuery("#system_access_manager_serveralias_warning").attr('title', UNAS._(
      'The labels in the domain name are composed of English letters and numbers, with each label not exceeding 63 characters and not distinguishing between uppercase and lowercase letters. No other punctuation marks can be used in the label except for the hyphen (-). The lowest level domain name is written on the far left, while the highest level domain name is written on the far right. A complete domain name composed of multiple labels should not exceed 255 characters in total.'
    ));
    return false;
  } else {
    jQuery("#system_access_manager_serveralias").attr('class', 'unas_input');
    jQuery("#system_access_manager_serveralias_warning").attr('class', "");
    jQuery("#system_access_manager_serveralias_warning").attr('title', '');
  }
  if (email_reg.exec(email) == null) {
    jQuery('#system_access_manager_serveradmin').attr('class', 'unas_input_error');
    jQuery("#system_access_manager_serveradmin_warning").attr('class', "unas_icon_error");
    jQuery("#system_access_manager_serveradmin_warning").attr('title', UNAS._('##$@systemaccess@$##Not valid email##$@systemaccess@$##'));
    return false;
  } else {
    jQuery("#system_access_manager_serveradmin").attr('class', 'unas_input');
    jQuery("#system_access_manager_serveradmin_warning").attr('class', "");
    jQuery("#system_access_manager_serveradmin_warning").attr('title', '');
  }
  if (port_reg.exec(https_port)) {
    if (port_reg.exec(https_port) > 65535 || port_reg.exec(https_port) < 0) {
      jQuery("#system_access_manager_https_port").attr('class', 'unas_input_error');
      jQuery("#system_access_manager_https_port_warning").attr('class', "unas_icon_error");
      jQuery("#system_access_manager_https_port_warning").attr('title', UNAS._('##$@systemaccess@$##Port must be 0~65535##$@systemaccess@$##'));
      return false;
    } else {
      jQuery("#system_access_manager_https_port").attr('class', 'unas_input');
      jQuery("#system_access_manager_https_port_warning").attr('class', "");
      jQuery("#system_access_manager_https_port_warning").attr('title', '');
    }
  } else {
    jQuery("#system_access_manager_https_port").attr('class', 'unas_input_error');
    jQuery("#system_access_manager_https_port_warning").attr('class', "unas_icon_error");
    jQuery("#system_access_manager_https_port_warning").attr('title', UNAS._('##$@systemaccess@$##Port must be 0~65535##$@systemaccess@$##'));
    return false;
  }
  if (port_reg.exec(http_port)) {
    if (port_reg.exec(http_port) > 65535 || port_reg.exec(http_port) < 0) {
      jQuery("#system_access_manager_http_port").attr('class', 'unas_input_error');
      jQuery("#system_access_manager_http_port_warning").attr('class', "unas_icon_error");
      jQuery("#system_access_manager_http_port_warning").attr('title', UNAS._('##$@systemaccess@$##Port must be 0~65535##$@systemaccess@$##'));
      return false;
    } else {
      jQuery("#system_access_manager_http_port").attr('class', 'unas_input');
      jQuery("#system_access_manager_http_port_warning").attr('class', "");
      jQuery("#system_access_manager_http_port_warning").attr('title', '');
    }
  } else {
    jQuery("#system_access_manager_http_port").attr('class', 'unas_input_error');
    jQuery("#system_access_manager_http_port_warning").attr('class', "unas_icon_error");
    jQuery("#system_access_manager_http_port_warning").attr('title', UNAS._('##$@systemaccess@$##Port must be 0~65535##$@systemaccess@$##'));
    return false;
  }
  return true;
}

function submit_setSystemAccess(block = true) {
  if (jQuery("#systemaccess_setup_submit").attr("class") == "unas_button_disabled") {
    return false;
  }
  if (block) {
    jQuery('#system_access_manager_cont_waiting').css('display', 'block');
    jQuery('#system_access_manager_cont_logo').css('display', 'block');
  }
  var name = jQuery("#system_access_manager_hostname").val();
  var serveralias = jQuery("#system_access_manager_serveralias").val();
  var email = jQuery("#system_access_manager_serveradmin").val();
  var http_port = jQuery("#system_access_manager_http_port").val();
  var https_port = jQuery("#system_access_manager_https_port").val();
  var policy = jQuery("#system_access_manager_access_policy").val();

  var data = {
    "cmd": "systemaccess_setting",
    "token": UToken,
    "params": {
      "hostname": name,
      "serveralias": serveralias,
      "http_port": http_port,
      "https_port": https_port,
      "policy": policy,
      "email": email
    }
  };

  jQuery.ajax({
    url: "/apps/systemaccess/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.stringify(data),
    timeout: 30000,
    dataType: "json",
    contentType: "application/json",
    success: function(data) {
      if (data.err == 0) {
        if (block) {
          var addr = window.document.location.protocol == "http:" ? "http://" + window.document.location.hostname + ":" + http_port : "https://" + window.document.location.hostname + ":" + https_port;
          jQuery('#system_access_manager_new_addr').attr('href', addr)
          jQuery('#system_access_manager_new_addr').attr('style', 'display:block');
        }
      }
      jQuery('#system_access_manager_cont_waiting').css('display', 'none');
      jQuery('#system_access_manager_cont_logo').css('display', 'none');
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
      jQuery('#system_access_manager_cont_waiting').attr("style", "display:none");
      jQuery('#system_access_manager_cont_logo').attr("style", "display:none");
    }
  })
}

function upload_cert() {
  var cwh = getClientWH();
  var systemaccess_upload_cert_window = new MUI.Modal({
    id: 'systemaccess_upload_cert',
    title: UNAS._('##$@systemaccess@$##Upload cert##$@systemaccess@$##'),
    contentURL: '/apps/systemaccess/m/systemaccess_upload_cert.html?v=6.0.20&',
    modal: true,
    modalOverlayClose: false,
    width: parseInt(cwh.w * 0.88),
    height: 230,
    addClass:'delete-modal'
  });
  systemaccess_upload_cert_window.refresh = function() {
    getSystemAccessInfo();
  }
}

function letsencrypt() {
  var cwh = getClientWH();
  submit_setSystemAccess(false);
  var systemaccess_letsencrypt_window = new MUI.Modal({
    id: 'systemaccess_letsencrypt',
    title: UNAS._("Let's encrypt"),
    contentURL: '/apps/systemaccess/m/systemaccess_letsencrypt.html?v=6.0.20&',
    modal: true,
    modalOverlayClose: false,
    width: cwh.w,
    height: cwh.h,
    addClass:'mobile-modal',
    type: 'modal2'
  });
  systemaccess_letsencrypt_window.refresh = function() {
    getSystemAccessInfo();
  }
}
